webapp/forms.py
"""Here WTF Forms definition"""

from flask_wtf import FlaskForm
from wtforms import StringField, SubmitField
from wtforms.validators import DataRequired, Regexp

# Regex to validate app url on aptoide
_URL_REGEX = r"""^https:\/\/[-a-zA-Z0-9]{1,256}\.[a-z]{2}\.aptoide\.com\/?$"""


class AptoidForm(FlaskForm):
    """WTF form to get the url we want to scrap, validates the url."""
    url = StringField(validators=[DataRequired(), Regexp(regex=_URL_REGEX, message="Invalid URL")])
    submit = SubmitField('Go')

webapp/__init__.py
import os

from flask import Flask, render_template
from flask_bootstrap import Bootstrap
from flask_wtf.csrf import CSRFProtect
from webapp import views


# noinspection PyUnusedLocal
def page_not_found(e):
    """
    Args:
        e:
    """
    return render_template('404.html'), 404


def create_app(test_config=None):
    # create and configure the app
    # noinspection PyShadowingNames
    """
    Args:
        test_config:
    """
    app = Flask(__name__, instance_relative_config=True)

    # Load the default configuration
    app.config.from_object('config.default')

    # ensure the instance folder exists
    try:
        os.makedirs(app.instance_path)
    except OSError:
        pass

    if test_config is None:
        # load the instance config, if it exists, when not testing
        app.config.from_pyfile('config.py', silent=True)
    else:
        # load the test config if passed in
        app.config.from_mapping(test_config)

    # Load the file specified by the APP_CONFIG_FILE environment variable
    # Variables defined here will override those in the default configuration
    if os.environ.get("APP_CONFIG_FILE"):
        app.config.from_envvar('APP_CONFIG_FILE')  # pragma: no cover

    # Register custom 404 page
    app.register_error_handler(404, page_not_found)

    # Bootstraps the app.
    # noinspection PyUnusedLocal
    bootstrap = Bootstrap(app)  # noqa F841

    # Csrf protection app wide.
    # noinspection PyUnusedLocal
    csrf = CSRFProtect(app)  # noqa F841

    # a simple page that says hello
    @app.route('/hello')
    def hello():
        return 'Hello, World!'

    # register the blueprint for views
    app.register_blueprint(views.simple_page)

    return app


app = create_app()

webapp/views.py
"""Here are the views for our webapp"""
from flask import Blueprint
from flask import render_template, flash

from scrapper.scrapping import get_page, parse_page
from .forms import AptoidForm

simple_page = Blueprint('simple_page', __name__)


@simple_page.route('/', methods=["GET", "POST"])
def index():
    """
    Main view of the webapp

    GET:    Displays the form for the user to enter an aptoide url

    POST:   Validates the form.
            Fetches the aptoide page, parses it and
            populates the template to show app information
    """
    form = AptoidForm()

    if form.validate_on_submit():
        status, resp = get_page(form.url.data)
        if status is True:
            data = parse_page(resp)
            return render_template('details.html', infos=data)
        else:
            form = AptoidForm()
            flash(resp, "error")
    return render_template('index.html', title="Get App Info", form=form)

webapp/templates/details.html
{% extends "layout.html" %}
{% block app_content %}
    <h1>Application details</h1>
    {% for info in infos %}
        <p>{{ info.0 }}: {{ info.1}}</p>
    {% endfor %}
<p><a href="{{ url_for('simple_page.index') }}">Back</a></p>
{% endblock %}

webapp/templates/index.html
{% extends "layout.html" %}
{% import 'bootstrap/wtf.html' as wtf %}

{% block app_content %}
    <h1>Get App Info</h1>
    <div class="row">
        <div class="col-md-4">
            {{ wtf.quick_form(form) }}
        </div>
    </div>
{% endblock %}

webapp/templates/layout.html
{% extends 'bootstrap/base.html' %}

{% block title %}
    {% if title %}{{ title }} - Aptoid Scrapper WebApp{% else %}Welcome to Aptoid Scrapper WebApp{% endif %}
{% endblock %}


{% block content %}
    <div class="container">
        {% with messages = get_flashed_messages() %}
        {% if messages %}
            {% for message in messages %}
            <div class="alert alert-warning alert-dismissible" role="alert">{{ message }}
              <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
             </button>
            </div>
            {% endfor %}
        {% endif %}
        {% endwith %}

        {% block app_content %}{% endblock %}
    </div>
{% endblock %}